import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import cx from "classnames";
import { useGlobalState } from "../lib/hooks";
const Container = ({ children }) => {
    const { state, dispatch } = useGlobalState();
    return (_jsxs("div", { className: cx(`__devine-child-container flex-grow h-screen overflow-y-scroll overflow-hidden relative z-0 transition-[border-radius,transform,opacity] duration-500`, !(state.containerPosition.x === 0 && state.containerPosition.y === 0) &&
            state.mode === `select` &&
            `rounded-2xl`, state.mode === `settings` && `opacity-20`), style: {
            transform: `translate(${state.mode === `select` ? state.containerPosition.x : 0}px, ${state.mode === `select` ? state.containerPosition.y : 0}px)`,
            transformOrigin: `top left`,
        }, children: [state.registeredComponents &&
                state.mode === `select` &&
                state.registeredComponents.map((c, i) => {
                    const elementX = c.element.getBoundingClientRect().left;
                    const elementY = c.element.getBoundingClientRect().top;
                    const elementWidth = c.element.getBoundingClientRect().width;
                    const elementHeight = c.element.getBoundingClientRect().height;
                    let zoomX = 0;
                    let zoomY = 0;
                    zoomX = (window.innerWidth - 400) / 2 - elementWidth / 2 - elementX;
                    zoomY = window.innerHeight / 2 - elementHeight / 2 - elementY;
                    return (_jsxs(_Fragment, { children: [state.selectedComponent === c.id && (_jsxs("div", { children: [_jsx("div", { className: "fixed bg-blue-500/20 h-screen w-0.5", style: { left: `${elementX - 6}px`, top: 0 } }), _jsx("div", { className: "fixed bg-blue-500/20 h-screen w-0.5", style: {
                                            left: `${elementX + elementWidth + 4}px`,
                                            top: 0,
                                        } }), _jsx("div", { className: "absolute bg-blue-500/20 w-screen h-0.5", style: { top: `${elementY - 6}px`, left: 0 } }), _jsx("div", { className: "absolute bg-blue-500/20 w-screen h-0.5", style: {
                                            top: `${elementY + elementHeight + 4}px`,
                                            left: 0,
                                        } })] }, `__devine-component-overlay--${c.type}_${i}__border`)), _jsx("div", { className: cx(`absolute rounded-xl hover:opacity-100 opacity-0 transition-opacity duration-300 cursor-pointer group flex items-center justify-center bg-blue-500/70 border-2 border-blue-500`, `__devine-component-overlay--${c.type}_${i}`), style: {
                                    left: `${elementX - 8}px`,
                                    top: `${elementY - 8}px`,
                                    width: `${elementWidth + 16}px`,
                                    height: `${elementHeight + 16}px`,
                                    zIndex: `1000`,
                                }, onClick: () => {
                                    dispatch({
                                        type: `moveContainer`,
                                        payload: { x: zoomX, y: zoomY },
                                    });
                                    dispatch({ type: `openSidebar` });
                                    dispatch({
                                        type: `selectComponent`,
                                        payload: c.id,
                                    });
                                }, children: _jsx("span", { className: "text-white text-3xl font-medium translate-y-2 group-hover:translate-y-0 transition-transform duration-300", children: c.type }) }, `__devine-component-overlay--${c.type}_${i}`)] }));
                }), children] }));
};
export default Container;
